ATB = {}
local g, c
for k, v in pairs(M.ATB) do
  g, c = k:match("(%w+)_([%w_]+)")
  if g then
    if g == "E" then g = "ERR" end
    if not ATB[g] then ATB[g] = {} end
    ATB[g][c] = v
  else
    ATB[k] = v
  end
end

ATB.TRJ.CMD_STEP = 0x8A
ATB.TRJ.CMD_LOAD = 2048  -- CMF_LOAD

ATB.INP.MAP =
{
  [ATB.INP.GO]   = { active = ATB.VAR.Inp_GO  , inactive = ATB.VAR.Inp_GO  , change = ATB.VAR.Chg_GO  , raising = ATB.VAR.Edg_GO  , falling = ATB.VAR.Rev_GO   };
  [ATB.INP.DIR]  = { active = ATB.VAR.Inp_DIR , inactive = ATB.VAR.Inp_DIR , change = ATB.VAR.Chg_DIR , raising = ATB.VAR.Edg_DIR , falling = ATB.VAR.Rev_DIR  };
  [ATB.INP.OFF]  = { active = ATB.VAR.Inp_OFF , inactive = ATB.VAR.Inp_OFF , change = ATB.VAR.Chg_OFF , raising = ATB.VAR.Edg_OFF , falling = ATB.VAR.Rev_OFF  };
  [ATB.INP.LIMP] = { active = ATB.VAR.Inp_LIMP, inactive = ATB.VAR.Inp_LIMP, change = ATB.VAR.Chg_LIMP, raising = ATB.VAR.Edg_LIMP, falling = ATB.VAR.Rev_LIMP };
  [ATB.INP.LIMN] = { active = ATB.VAR.Inp_LIMN, inactive = ATB.VAR.Inp_LIMN, change = ATB.VAR.Chg_LIMN, raising = ATB.VAR.Edg_LIMN, falling = ATB.VAR.Rev_LIMN };
}


M.SDRV = getmetatable(M.Axes[1])

local PosUM = function(A) return A.UM end
local A = M.Axes[1]
A.__properties = 
{
  -- sdrv = OFF_SDRV + (user - OFF_USER) * FS_SDRV / FS_USER
  -- user = OFF_USER + (sdrv - OFF_SDRV) * FS_USER / FS_SDRV

  { Name = "Name" };
  { Name = "ID" };
  { Name = "Ver" };
  { Name = "Address" };
  { Name = "Locked" };
  { Name = "IsSelected" };
  { Name = "IsDisabled" };
  { Name = "IsReady" };
  { Name = "IsHomed" };
  { Name = "InMotion" };
  { Name = "IsTrjDone" };
  { Name = "IsSeqBusy" };
  { Name = "OnTarget" };
  { Name = "UM" };
  { Name = "UMMul" };
  { Name = "UMDiv" };
  { Name = "SPT", UM = "S/rot" };
  { Name = "Steps", UM = "S" };
  { Name = "Pos", Alias = "Position", UM = PosUM };
  { Name = "Target", UM = PosUM };
  { Name = "Min", UM = PosUM };
  { Name = "Max", UM = PosUM };
  { Name = "Offset", UM = PosUM };
  { Name = "Home", UM = PosUM };
  { Name = "Parking", UM = PosUM };
  { Name = "Enc1Res", UM = "incr" };
  { Name = "Enc2Res", UM = "incr" };
  { Name = "Enc1", Alias = "Encoder1", UM = "incr" };
  { Name = "Enc2", Alias = "Encoder2", UM = "incr" };
  { Name = "VelScale", Alias = "SpeedScale", Fmt = "%.3f" };
  { Name = "Vel", Alias = "Speed", UM = "rpm" };
  { Name = "VelMax", Alias = "SpeedMax", UM = "rpm" };
  { Name = "VelEnterHome" , Index12 = ATB.PAR.App_VelEnterHome, Index13 = ATB.PAR13.App_VelEnterHome, Long = false, Min = 0, Max = 10000, UM = "rpm", Fmt = "%i" };
  { Name = "VelExitHome"  , Index12 = ATB.PAR.App_VelExitHome , Index13 = ATB.PAR13.App_VelExitHome , Long = false, Min = 1, Max = 10000, UM = "rpm", Fmt = "%i" };
  { Name = "AccMax"       , Index12 = ATB.PAR.Trj_AccMax      , Index13 = ATB.PAR13.Trj_AccMax      , Long = false, Min = 1, Max = 32767, UM = "rpm/s", Fmt = "%i" };
  { Name = "DecMax"       , Index12 = ATB.PAR.Trj_DecMax      , Index13 = ATB.PAR13.Trj_DecMax      , Long = false, Min = 0, Max = 32767, UM = "rpm/s", Fmt = "%i" };
  { Name = "DecLim"       , Index12 = ATB.PAR.Trj_DecLim      , Index13 = ATB.PAR13.Trj_DecLim      , Long = false, Min = 0, Max = 32767, UM = "rpm/s", Fmt = "%i" };
  { Name = "AccHome"      , Index12 = ATB.PAR.App_AccHome     , Index13 = ATB.PAR13.App_AccHome     , Long = false, Min = 0, Max = 32767, UM = "rpm/s", Fmt = "%i" };
  { Name = "DecHome"      , Index12 = ATB.PAR.App_DecHome     , Index13 = ATB.PAR13.App_DecHome     , Long = false, Min = 0, Max = 32767, UM = "rpm/s", Fmt = "%i" };
  { Name = "CurMax"       , Index12 = ATB.PAR.Cur_Max         , Index13 = ATB.PAR13.Cur_Max         , Long = false, Min = 1, Max = 100, FS_SDRV = 32768, FS_USER = 100, UM = "%", Fmt = "%.0f" };
  { Name = "CurIdle"      , Index12 = ATB.PAR.Cur_Idle        , Index13 = ATB.PAR13.Cur_Idle        , Long = false, Min = 0, Max = 100, FS_SDRV = 32768, FS_USER = 100, UM = "%", Fmt = "%.0f" };
  { Name = "CurRun"       , Index12 = ATB.PAR.Cur_Run         , Index13 = ATB.PAR13.Cur_Run         , Long = false, Min = 1, Max = 100, FS_SDRV = 32768, FS_USER = 100, UM = "%", Fmt = "%.0f" };
  { Name = "CurAcc"       , Index12 = ATB.PAR.Cur_Acc         , Index13 = ATB.PAR13.Cur_Acc         , Long = false, Min = 1, Max = 100, FS_SDRV = 32768, FS_USER = 100, UM = "%", Fmt = "%.0f" };
  { Name = "AN", Alias = "Analog" };                                             
  { Name = "LIMN" };                                                           
  { Name = "LIMP" };
  { Name = "GO" };
  { Name = "DIR" };
  { Name = "RDY" };
}

for _, p in ipairs(A.__properties) do
  p.FS_USER  = p.FS_USER  or 1
  p.FS_SDRV  = p.FS_SDRV  or 1
  p.OFF_USER = p.OFF_USER or 0
  p.OFF_SDRV = p.OFF_SDRV or 0
  p.Min = p.Min or p.OFF_USER
  p.Max = p.Max or p.OFF_USER + p.FS_USER
  p.Fmt = p.Fmt or "%s"
  p.UM  = p.UM  or ""

  if p.Index12 or p.Index13 then
    A["__get_"..p.Name] = function(self)
      return p.OFF_USER + (self:Get(self.Ver == "1.3" and p.Index13 or p.Index12, p.Long) - p.OFF_SDRV) * p.FS_USER / p.FS_SDRV
    end

    A["__set_"..p.Name] = function(self, user)
      return self:Set(self.Ver == "1.3" and p.Index13 or p.Index12, math.limit(p.OFF_SDRV + (math.limit(user, p.Min, p.Max) - p.OFF_USER) * p.FS_SDRV / p.FS_USER, 0, p.Long and 2^15-1 or 2^31-1), p.Long)
    end
  end
  A.__properties[p.Name] = p
  if p.Alias then
    A.__properties[p.Alias] = p
    A["__get_"..p.Alias] = A["__get_"..p.Name]
    A["__set_"..p.Alias] = A["__set_"..p.Name]
  end
end

   
function M:dump(...)
  local axes = select("#", ...) == 0 and M.Axes or {...}
  local um, fmt, val
  for _, p in ipairs(M.Axes[1].__properties) do
    s = string.alignleft(p.Name, 12)
    for _, A in ipairs(axes) do --if A.IsReady then
      fmt = type(p.Fmt) == "function" and p.Fmt(A) or p.Fmt
      try val = string.format(fmt, tostring(A[p.Name]))
      catch err do val = "?" end
      s = s .. " | " .. string.alignright(val, 11)
    end --end
    um = type(p.UM) == "function" and p.UM(M.Axes[1]) or p.UM
    s = s .. string.format(" | %s", string.alignleft(um, 8))
    print(s)
  end
end


function M:dumpen()
  local axes = {}
  for _, A in ipairs(M.Axes) do if not A.IsDisabled then axes[#axes+1] = A end end
  return M:dump(unpack(axes))
end


-----------------------------------------------------------------------------------
function ATB.SEQ.dbgbreak()
  return { Source = "suspend"; (dbg and dbg()) and ATB.SEQ.OP_BREAK or ATB.SEQ.OP_NOP, 0, 0, 0, 0, 0, 0, 0 }
end


function ATB.SEQ.suspend()
  return { Source = "suspend"; ATB.SEQ.OP_BREAK, 0, 0, 0, 0, 0, 0, 0 }
end


function ATB.SEQ.clear()
  return { Source = "clear"; ATB.SEQ.OP_RESET, 0, 0, 0, 0, 0, 0, 0 }
end


function ATB.SEQ.ret()
  return { Source = "ret"; ATB.SEQ.OP_RET, 0, 0, 0, 0, 0, 0, 0 }
end


function ATB.SEQ.call(line)
  line = line or 250
  if line < 0 or line >= 250 then error("bad argument") end
  return { Source = "goto " .. line; ATB.SEQ.OP_CALL, line, 0, 0, 0, 0, 0, 0 }
end


function ATB.SEQ.goto(line)
  line = line or 250
  if line < 0 or line >= 250 then error("bad argument") end
  return { Source = "goto " .. line; ATB.SEQ.OP_GOTO, line, 0, 0, 0, 0, 0, 0 }
end


function ATB.SEQ.jump(rel)
  rel = rel or 128
  if rel < -128 or rel >= 128 then error("bad argument") end
  return { Source = "goto " .. line; ATB.SEQ.OP_JUMP, line, 0, 0, 0, 0, 0, 0 }
end


function ATB.SEQ.wait(dt)
  if not dt then error("bad argument") end
  dt = dt * 1000
  return { Source = "wait " .. dt .. " ms"; ATB.SEQ.OP_WAIT, dt, 0, 0, 0, 0, 0, 0 }
end


-- dst(i) <- src(j, k)
function ATB.SEQ.move(dst, src)
  local src_ct  = type(src) == "number"
  local src_par = ATB.PAR[src]
  local src_var = ATB.VAR[src]
  local dst_par = ATB.PAR[dst]
  local dst_var = ATB.VAR[dst]
  local sam, i, j, k
  if dst_par then
    if     src_var then  sam = ATB.SAM.PAR_SIG  i = dst_par  j = src_var       k   = 0              -- P[i] <- V[j]
    elseif src_ct  then  sam = ATB.SAM.PAR_CT   i = dst_par  j = bit.lsw(src)  k   = bit.msw(src)   -- P[i] <- CT = j + k << 16
    end
  elseif dst_var then
    if     src_var then  sam = ATB.SAM.SIG_SIG  i = dst_var  j = src_var       k   = 0              -- V[i] <- V[j]
    elseif src_par then  sam = ATB.SAM.SIG_PAR  i = dst_var  j = src_par       k   = 0              -- V[i] <- P[j]
    elseif src_ct  then  sam = ATB.SAM.SIG_CT   i = dst_var  j = bit.lsw(src)  k   = bit.msw(src)   -- V[i] <- CT = j + k << 16
    end
  end
  if sam and i and j and k then return
  { -- op, opflags; word0 = j, word1 = k; word2 = sam + i; word3, word4, word5
    ATB.SEQ.OP_MOVE, 0; j, k; sam + i; 0, 0, 0;
    Source = string.format("%s = %s", dst, src)
  }
  else error("bad arguments") end
end
--dump(ATB.SEQ.move("Acc_Setpoint", "App_AccHome"))
--dump(ATB.SEQ.move("Edg_LIMN", 123))


function ATB.SEQ.trj_exec(cmd, mflg, vflg, dt)
  dt = dt or 0
  return { Source = "trj_exec"; ATB.SEQ.OP_TRAJEXEC, dt * 1000, mflg or ATB.TRJ.DONE, vflg or ATB.TRJ.DONE, cmd, 0, 0, 0 }
end


function ATB.SEQ.trj_wait(dt, mflg, vflg)
  dt = dt or 0
  return { Source = "trj_wait"; ATB.SEQ.OP_TRAJWAIT, dt * 1000, mflg or ATB.TRJ.DONE, vflg or ATB.TRJ.DONE, 0, 0, 0, 0 }
end


function ATB.SEQ.trj_origin(flg, vin, vout, ain, din, off)
  return { Source = "trj_origin"; ATB.SEQ.OP_HOMING, flg or -1, vin or 0, vout or 0, ain or 0, din or 0, bit.lsw(off or 0), bit.msw(off or 0) }
end


-----------------------------------------------------------------------------------
function ATB.SEQ.new(mot)
  local seq = {}
  local meta =
  {
    suspend = function(self) self[#self+1] = ATB.SEQ.suspend() end;
    ret = function(self) self[#self+1] = ATB.SEQ.ret() end;
    clear = function(self) self[#self+1] = ATB.SEQ.clear() end;
    move = function(self, dst, src) self[#self+1] = ATB.SEQ.move(dst, src) end;
    wait = function(self, dt) self[#self+1] = ATB.SEQ.wait(dt) end;
    call = function(self, line) self[#self+1] = ATB.SEQ.call(line) end;
    goto = function(self, line) self[#self+1] = ATB.SEQ.goto(line) end;
    jump = function(self, rel) self[#self+1] = ATB.SEQ.jump(rel) end;

    trj_load = function(self, pos)
      self[#self+1] = ATB.SEQ.move("Pos_Capture", mot and mot:UMToMicrostep(pos) or pos)
      self[#self+1] = ATB.SEQ.trj_exec(ATB.TRJ.CMD_LOAD, mflg, vflg, dt)
      self[#self].Source = "trj_load"
    end;

    trj_goto = function(self, pos, vel, dt)
      dt = dt or 0
      if vel then self[#self+1] = ATB.SEQ.move("Vel_Setpoint", mot and mot:RPM(vel) or vel) end
      self[#self+1] = ATB.SEQ.move("Pos_Setpoint", mot and mot:UMToMicrostep(pos) or pos)
      self[#self+1] = ATB.SEQ.trj_exec(ATB.TRJ.CMD_GOTO, mflg, vflg, dt)
      self[#self].Source = "trj_goto" .. (dt < 0 and "" or dt > 0 and string.format(" and wait eom %g ms", dt * 1000) or " and wait eom forever")
    end;

    trj_goto2 = function(self, pos, vel, acc, dec, dt)
      dt = dt or 0
      if acc then self[#self+1] = ATB.SEQ.move("Acc_Setpoint", acc) end
      if dec then self[#self+1] = ATB.SEQ.move("Dec_Setpoint", dec) end    
      if vel then self[#self+1] = ATB.SEQ.move("Vel_Setpoint", mot and mot:RPM(vel) or vel) end
      self[#self+1] = ATB.SEQ.move("Pos_Setpoint", mot and mot:UMToMicrostep(pos) or pos)
      self[#self+1] = ATB.SEQ.trj_exec(ATB.TRJ.CMD_GOTO, mflg, vflg, dt)
      self[#self].Source = "trj_goto" .. (dt < 0 and "" or dt > 0 and string.format(" and wait eom %g ms", dt * 1000) or " and wait eom forever")
    end;

    trj_move = function(self, dist, vel, dt)
      dt = dt or 0
      if vel then self[#self+1] = ATB.SEQ.move("Vel_Setpoint", mot and mot:RPM(vel) or vel) end
      self[#self+1] = ATB.SEQ.move("Pos_Setpoint", mot and mot:UMToMicrostep(dist) or dist)
      self[#self+1] = ATB.SEQ.trj_exec(ATB.TRJ.CMD_STEP, mflg, vflg, dt)
      self[#self].Source = "trj_move" .. (dt < 0 and "" or dt > 0 and string.format(" and wait eom %g ms", dt * 1000) or " and wait eom forever")
    end;

    trj_move2 = function(self, dist, vel, acc, dec, dt)
      dt = dt or 0
      if acc then self[#self+1] = ATB.SEQ.move("Acc_Setpoint", acc) end
      if dec then self[#self+1] = ATB.SEQ.move("Dec_Setpoint", dec) end    
      if vel then self[#self+1] = ATB.SEQ.move("Vel_Setpoint", mot and mot:RPM(vel) or vel) end
      self[#self+1] = ATB.SEQ.move("Pos_Setpoint", mot and mot:UMToMicrostep(dist) or dist)
      self[#self+1] = ATB.SEQ.trj_exec(ATB.TRJ.CMD_STEP, mflg, vflg, dt)
      self[#self].Source = "trj_move" .. (dt < 0 and "" or dt > 0 and string.format(" and wait eom %g ms", dt * 1000) or " and wait eom forever")
    end;

    trj_start = function(self, vel, dt)
      if not vel then error("bad arguments") end
      dt = dt or 0
      self[#self+1] = ATB.SEQ.move("Vel_Setpoint", mot and mot:RPM(vel) or vel)
      self[#self+1] = ATB.SEQ.trj_exec(ATB.TRJ.CMD_START, mflg, vflg, dt)
      self[#self].Source = "trj_start" .. (dt < 0 and "" or dt > 0 and string.format(" and wait eom %g ms", dt * 1000) or " and wait eom forever")
    end;

    trj_stop = function(self, dt)
      dt = dt or 0
      --self[#self+1] = ATB.SEQ.move("Acc_Setpoint", "Trj_AccMax")
      --self[#self+1] = ATB.SEQ.move("Dec_Setpoint", "Trj_DecMax")
      self[#self+1] = ATB.SEQ.trj_exec(ATB.TRJ.CMD_STOP, mflg, vflg, dt)
      self[#self].Source = "trj_stop" .. (dt < 0 and "" or dt > 0 and string.format(" and wait eom %g ms", dt * 1000) or " and wait eom forever")
    end;

    trj_wait = function(self, dt, mflg, vflg)
      self[#self+1] = ATB.SEQ.trj_wait(dt, mflg, vflg)
    end;
  }
  meta.__index = meta
  setmetatable(seq, meta)
  return seq
end




-----------------------------------------------------------------------------------
function M.SDRV:DebugSeq(seq)
  local progress_count = 0
  local function progress(n)
    n = n or 5
    progress_count = progress_count + 1
    if progress_count > n then progress_count = 1 end
    return string.rep(".", progress_count - 1), string.rep(".", n - progress_count + 1)
  end


  local old_setup = UI.Buttons
  local old_text  = UI.Text
  local s, p1, p2
  while true do
    cmd = ""
    UI:Wait(0, function()
      p1, p2 = progress()
      s = self:Status()
      if s.SeqSize == 0 then UI:CancelWait() end
      return string.format("%sP", (#UI.Input > 0 or s.IsSeqSuspended) and "S" or "s"), string.format(
        "#s[9]#f[ShareMono]#c[lightgrey] { %s }#p" ..
        "#n%i / %i  |  %s#p" ..
        "#s[9]%s",
        s.SeqIndex < s.SeqSize and seq[s.SeqIndex+1].Source or "end",
        s.SeqIndex, s.SeqSize,
        s.IsSeqSuspended and "#c[red]{Suspended}" or (s.IsSeqIdle and "#c[green]{Idle}" or ("#c[green]{Running} #c[white]{" .. p1 .. "}#c[black]{" .. p2 .. "}")),
        UI.Input)
    end)
    if s.SeqSize == 0 then break end

    if #UI.Input > 0 then
      if UI.Button == "S" then
        for k, v in opairs(ATB.VAR) do
          if k:find(UI.Input) then
            v = self:Read(v)
            printf("%s.ATB.VAR.%s = %10i | %s | %s", self.ID, string.alignleft(k, 16), v, bit.tohex(v, 8), bit.tobin(v, 32))
          end
        end
      else
        print(UI.Input)
        assert(loadstring(UI.Input))()
      end
      UI.Input = ""
    elseif UI.Button == "S" then self:StartSeq()
    elseif UI.Button == "P" then 
      if s.IsSeqSuspended then
        self:StopSeq()
        self:Stop()
      else
        self:PauseSeq()
      end
    end
  end
  UI:Msg(old_setup, old_text)
end


function M.SDRV:RunSeqDbg(seq) self:RunSeq(seq) if dbg() then self:DebugSeq(seq) end end


function M.SDRV:Enter(lim, vel, dist, to)
  local neg = lim == ATB.INP.LIMN
  local lim_edg = neg and ATB.VAR.Edg_LIMN or ATB.VAR.Edg_LIMP
  vel  = self:RPM(vel) * (neg and -1 or 1)
  local seq = data.stack()                             -- op, opflags, word0, word1, word2, word3, word4, word5
  seq:push   { Source = "lim_edg = 0";                 ATB.SEQ.OP_MOVE, 0, 0, 0, ATB.SAM.SIG_CT+lim_edg, 0, 0, 0 }
  seq:push   { Source = "Acc_Setpoint = Trj_AccMax";   ATB.SEQ.OP_MOVE, 0, ATB.PAR.Trj_AccMax, 0, ATB.SAM.SIG_PAR+ATB.VAR.Acc_Setpoint, 0, 0, 0 }
  seq:push   { Source = "Dec_Setpoint = Trj_DecMax";   ATB.SEQ.OP_MOVE, 0, ATB.PAR.Trj_DecMax, 0, ATB.SAM.SIG_PAR+ATB.VAR.Dec_Setpoint, 0, 0, 0 }
  seq:push   { Source = "Vel_Setpoint = vel";          ATB.SEQ.OP_MOVE, 0, bit.lsw(vel), bit.msw(vel), ATB.SAM.SIG_CT+ATB.VAR.Vel_Setpoint, 0, 0, 0 }
  seq:push   { Source = "trj_trig if lim_edg = -1";    ATB.SEQ.OP_TRAJTRIG, 0, lim_edg, -1, 0, 0, 0, 0 }
  if dist then
    dist = self:UMToMicrostep(dist)
    seq:push { Source = "trj_start capture if trig";   ATB.SEQ.OP_TRAJEXEC, 0, ATB.TRJ.TRIGGERED, ATB.TRJ.TRIGGERED, ATB.TRJ.CMD_START+ATB.TRJ.CMF_CAPTURE, 0, 0, 0 }
    seq:push { Source = "Vel_Setpoint = Trj_VelMax";   ATB.SEQ.OP_MOVE, 0, ATB.PAR.Trj_VelMax, 0, ATB.SAM.SIG_PAR+ATB.VAR.Vel_Setpoint, 0, 0, 0 }
    seq:push { Source = "Pos_Setpoint = Pos_Capture";  ATB.SEQ.OP_MOVE, 0, ATB.VAR.Pos_Capture, 0, ATB.SAM.SIG_SIG+ATB.VAR.Pos_Setpoint, 0, 0, 0 }
    seq:push { Source = "Pos_Setpoint += dist";        ATB.SEQ.OP_EVAL, 0, ATB.SOP.ADD+ATB.VAR.Pos_Setpoint+ATB.SIG.FS2CONST, bit.lsw(dist), bit.msw(dist), 0, 0, 0 }
    seq:push { Source = "trj_goto";                    ATB.SEQ.OP_TRAJEXEC, 0, ATB.TRJ.DONE, ATB.TRJ.DONE, ATB.TRJ.CMD_GOTO, 0, 0, 0 }
  else
    seq:push { Source = "trj_start stop if trig";      ATB.SEQ.OP_TRAJEXEC, 0, ATB.TRJ.INMOTION, 0, ATB.TRJ.CMD_START+ATB.TRJ.CMF_SEARCH, 0, 0, 0 }
  end
  self:RunSeq(seq)
  if to then self:Wait(to) end
end


function M.SDRV:Exit(lim, vel, dist, to)
  local neg = lim == ATB.INP.LIMN
  local lim_edg = neg and ATB.VAR.Rev_LIMN or ATB.VAR.Rev_LIMP
  vel  = self:RPM(vel) * (neg and 1 or -1)
  local seq = data.stack()                             -- op, opflags, word0, word1, word2, word3, word4, word5
  seq:push   { Source = "lim_edg = 0";                 ATB.SEQ.OP_MOVE, 0, 0, 0, ATB.SAM.SIG_CT+lim_edg, 0, 0, 0 }
  seq:push   { Source = "Acc_Setpoint = Trj_AccMax";   ATB.SEQ.OP_MOVE, 0, ATB.PAR.Trj_AccMax, 0, ATB.SAM.SIG_PAR+ATB.VAR.Acc_Setpoint, 0, 0, 0 }
  seq:push   { Source = "Dec_Setpoint = Trj_DecMax";   ATB.SEQ.OP_MOVE, 0, ATB.PAR.Trj_DecMax, 0, ATB.SAM.SIG_PAR+ATB.VAR.Dec_Setpoint, 0, 0, 0 }
  seq:push   { Source = "Vel_Setpoint = vel";          ATB.SEQ.OP_MOVE, 0, bit.lsw(vel), bit.msw(vel), ATB.SAM.SIG_CT+ATB.VAR.Vel_Setpoint, 0, 0, 0 }
  seq:push   { Source = "trj_trig if lim_edg = -1";    ATB.SEQ.OP_TRAJTRIG, 0, lim_edg, -1, 0, 0, 0, 0 }
  if dist then
    dist = self:UMToMicrostep(dist)
    seq:push { Source = "trj_start capture if trig";   ATB.SEQ.OP_TRAJEXEC, 0, ATB.TRJ.TRIGGERED, ATB.TRJ.TRIGGERED, ATB.TRJ.CMD_START+ATB.TRJ.CMF_CAPTURE, 0, 0, 0 }
    seq:push { Source = "Vel_Setpoint = Trj_VelMax";   ATB.SEQ.OP_MOVE, 0, ATB.PAR.Trj_VelMax, 0, ATB.SAM.SIG_PAR+ATB.VAR.Vel_Setpoint, 0, 0, 0 }
    seq:push { Source = "Pos_Setpoint = Pos_Capture";  ATB.SEQ.OP_MOVE, 0, ATB.VAR.Pos_Capture, 0, ATB.SAM.SIG_SIG+ATB.VAR.Pos_Setpoint, 0, 0, 0 }
    seq:push { Source = "Pos_Setpoint += dist";        ATB.SEQ.OP_EVAL, 0, ATB.SOP.ADD+ATB.VAR.Pos_Setpoint+ATB.SIG.FS2CONST, bit.lsw(dist), bit.msw(dist), 0, 0, 0 }
    seq:push { Source = "trj_goto";                    ATB.SEQ.OP_TRAJEXEC, 0, ATB.TRJ.DONE, ATB.TRJ.DONE, ATB.TRJ.CMD_GOTO, 0, 0, 0 }
  else
    seq:push { Source = "trj_start stop if trig";      ATB.SEQ.OP_TRAJEXEC, 0, ATB.TRJ.INMOTION, 0, ATB.TRJ.CMD_START+ATB.TRJ.CMF_SEARCH, 0, 0, 0 }
  end
  self:RunSeq(seq)
  if to then self:Wait(to) end
end


function M.SDRV:Search(edg, inp, vel, dist, to)
  local var = ATB.INP.MAP[inp] if not var then error("bad input line") end
  if edg:find("active")                   then error("bad search mode") end
  var = var[edg]               if not var then error("bad search mode") end
  vel  = self:RPM(vel)
  local seq = data.stack()                             -- op, opflags, word0, word1, word2, word3, word4, word5
  seq:push   { Source = "inp_edg = 0";                 ATB.SEQ.OP_MOVE, 0, 0, 0, ATB.SAM.SIG_CT+var, 0, 0, 0 }
  seq:push   { Source = "Acc_Setpoint = Trj_AccMax";   ATB.SEQ.OP_MOVE, 0, ATB.PAR.Trj_AccMax, 0, ATB.SAM.SIG_PAR+ATB.VAR.Acc_Setpoint, 0, 0, 0 }
  seq:push   { Source = "Dec_Setpoint = Trj_DecMax";   ATB.SEQ.OP_MOVE, 0, ATB.PAR.Trj_DecMax, 0, ATB.SAM.SIG_PAR+ATB.VAR.Dec_Setpoint, 0, 0, 0 }
  seq:push   { Source = "Vel_Setpoint = vel";          ATB.SEQ.OP_MOVE, 0, bit.lsw(vel), bit.msw(vel), ATB.SAM.SIG_CT+ATB.VAR.Vel_Setpoint, 0, 0, 0 }
  seq:push   { Source = "trj_trig if inp_edg = -1";    ATB.SEQ.OP_TRAJTRIG, 0, var, -1, 0, 0, 0, 0 }
  if dist then
    dist = self:UMToMicrostep(dist)
    seq:push { Source = "trj_start capture if trig";   ATB.SEQ.OP_TRAJEXEC, 0, ATB.TRJ.TRIGGERED, ATB.TRJ.TRIGGERED, ATB.TRJ.CMD_START+ATB.TRJ.CMF_CAPTURE, 0, 0, 0 }
    seq:push { Source = "Vel_Setpoint = Trj_VelMax";   ATB.SEQ.OP_MOVE, 0, ATB.PAR.Trj_VelMax, 0, ATB.SAM.SIG_PAR+ATB.VAR.Vel_Setpoint, 0, 0, 0 }
    seq:push { Source = "Pos_Setpoint = Pos_Capture";  ATB.SEQ.OP_MOVE, 0, ATB.VAR.Pos_Capture, 0, ATB.SAM.SIG_SIG+ATB.VAR.Pos_Setpoint, 0, 0, 0 }
    seq:push { Source = "Pos_Setpoint += dist";        ATB.SEQ.OP_EVAL, 0, ATB.SOP.ADD+ATB.VAR.Pos_Setpoint+ATB.SIG.FS2CONST, bit.lsw(dist), bit.msw(dist), 0, 0, 0 }
    seq:push { Source = "trj_goto";                    ATB.SEQ.OP_TRAJEXEC, 0, ATB.TRJ.DONE, ATB.TRJ.DONE, ATB.TRJ.CMD_GOTO, 0, 0, 0 }
  else
    seq:push { Source = "trj_start stop if trig";      ATB.SEQ.OP_TRAJEXEC, 0, ATB.TRJ.INMOTION, 0, ATB.TRJ.CMD_START+ATB.TRJ.CMF_SEARCH, 0, 0, 0 }
  end
  self:RunSeq(seq)
  if to then self:Wait(to) end
end


-----------------------------------------------------------------------------------
M.SDRV.TrjRun = function(A, cmd, pos, vel, acc, dec, sig, mask, val, to)
  A:Command(ATB.CMD.TRJRUN, cmd, A:UMToMicrostep(pos or 0), A:RPM(vel or 1), A:RPM(acc or 0) + A:RPM(dec or 0) * 65536, (val or 1) + (mask or 1) * 65536, sig)
  if to then A:Wait(to, "trig") end
end

